import objectdraw.*;

/**
   Main controller class for Flowers lab

   This program will create a new Flower each time the mouse is
   pressed on the canvas.  As the mouse is dragged, the Flower is
   instructed to grow.  If the mouse is pressed again on the most
   recently created Flower, it will be instructed to change its color.

   Note: You should not make any modifications to this class.

   Implementation from Bruce, Danyluk, Murtagh, Williams College

   Formatted and documented by Jim Teresco, Siena College, for
   CSIS 120 Labs, Spring 2011.
   Updated again for The College of Saint Rose, Fall 2013

   $Id: Spring.java 1550 2011-02-23 21:44:52Z terescoj $
*/

public class Spring extends WindowController {
    
    /* Remember the most recently created flower */
    private Flower newestFlower;
        
    /* Create a new flower or change the color of the last flower */
    public void onMousePress( Location point ) {

        if ( newestFlower != null && newestFlower.flowerContains(point) ) {
            newestFlower.changeColor();
        } 
        else {
            newestFlower = new Flower( point, canvas.getHeight()*.5, canvas );
        }
    }
    
    /* Make the newest flower grow a little as the mouse is dragged */
    public void onMouseDrag( Location point ) {

        if ( newestFlower != null ) {
            newestFlower.grow();
        }
    }
    
    /* Clear the canvas to start again when the mouse moves into the window */
    public void onMouseEnter(Location pt) {

        canvas.clear();
        newestFlower = null;
    }
}
